#include <sys/types.h>
#include <sys/time.h>

int read_array[100];
int write_array[100];
int ex_array[100];
int num_readarray;
int num_writearray;
int num_exarray;

test()
{
   fd_set rfds;   /* file descriptors for reading         */
   fd_set wfds;   /* file descriptors for writing         */
   fd_set efds;   /* file descriptors for exc. conditions */
   fd_set t_rfds; /* temporary set for reading            */
   fd_set t_wfds; /* temporary set for writing            */
   fd_set t_efds; /* temporary set for exceptions         */
   int    max_fd; /* max file descriptor of all sets      */
   int    i;      /* loop index counter                   */
   int    n_fds;  /* return value of select()             */

   if (num_readarray == 0
     && num_writearray == 0
     && num_exarray == 0) {
        /*
         *  No elements in any array...
         */
        return;
   }

   max_fd = 0;
   FD_ZERO(&rfds);
   FD_ZERO(&wfds);
   FD_ZERO(&efds);

   for (i = 0; i < num_readarray; i++) {
      FD_SET(read_array[i], &rfds);
      if (read_array[i] > max_fd)
         max_fd = read_array[i];
   }
   for (i = 0; i < num_writearray; i++) {
      FD_SET(write_array[i], &wfds);
      if (write_array[i] > max_fd)
         max_fd = write_array[i];
   }
   for (i = 0; i < num_exarray; i++) {
      FD_SET(ex_array[i], &efds);
      if (ex_array[i] > max_fd)
         max_fd = ex_array[i];
   }

   max_fd ++;

   for (;;) {
      /*
       *  Use a copy so we don't lose the original sets.
       */
      t_rfds = rfds;
      t_wfds = wfds;
      t_efds = efds;

      if ((n_fds = select(max_fd, &t_rfds, &t_wfds,
                   &t_efds, 0)) < 0) {
          /*  Error condition.  */
          break;
      }
      for (i = 0; i < num_readarray; i++) {
         if (FD_ISSET(read_array[i], &t_rfds)) {
            /*
             *  Read data from read_array[i].
             */
         }
      }
      for (i = 0; i < num_writearray; i++) {
         if (FD_ISSET(write_array[i], &t_wfds)) {
            /*
             *  Write data to write_array[i].
             */
         }
      }
      for (i = 0; i < num_exarray; i++) {
         if (FD_ISSET(ex_array[i], &t_efds)) {
            /*
             *  Process data from ex_array[i].
             */
         }
      }
   }
}
