#include <fcntl.h>
#include <sys/file.h>
#include <sys/signal.h>

int
setup_signals(socket)
int socket;
{
   int normal_data();
   int expedited_data();

   (void)signal(SIGIO, normal_data);
   (void)signal(SIGURG, expedited_data);

   /*
    *  Associate our process with the socket.
    */

   if (fcntl(socket, F_SETOWN, getpid()) < 0) {
      return(0);
   }

   /*
    *  Tell the system to send us SIGIO or SIGURG when
    *  data arrive.
    */

   if (fcntl(socket, F_SETFL, FASYNC)  < 0) {
      return(0);
   }

   return(1);
}
